## mingw-w64-gdal-3.11.3-1.src.tar.zst

=== frmts/grib/CMakeLists.txt ===
add_gdal_driver(
  TARGET gdal_GRIB
  SOURCES gribdataset.cpp
          gribcreatecopy.cpp
          degrib/degrib/clock.c
          degrib/degrib/degrib1.cpp
          degrib/degrib/degrib2.cpp
          degrib/degrib/inventory.cpp
          degrib/degrib/metaname.cpp
          degrib/degrib/myerror.cpp
          degrib/degrib/grib1tab.cpp
          degrib/degrib/myutil.c
          degrib/degrib/metaparse.cpp
          degrib/degrib/weather.c
          degrib/degrib/metaprint.cpp
          degrib/degrib/grib2api.c
          degrib/degrib/myassert.c
          degrib/degrib/scan.c
          degrib/degrib/tendian.cpp
          degrib/g2clib/gridtemplates.c
          degrib/g2clib/drstemplates.c
          degrib/g2clib/pdstemplates.c
          degrib/g2clib/gbits.c
          degrib/g2clib/g2_free.c
          degrib/g2clib/g2_unpack1.c
          degrib/g2clib/g2_unpack2.c
          degrib/g2clib/g2_unpack3.c
          degrib/g2clib/g2_unpack4.c
          degrib/g2clib/g2_unpack5.c
          degrib/g2clib/g2_unpack6.c
          degrib/g2clib/g2_unpack7.c
          degrib/g2clib/g2_info.c
          degrib/g2clib/g2_getfld.c
          degrib/g2clib/simunpack.c
          degrib/g2clib/comunpack.c
          degrib/g2clib/pack_gp.c
          degrib/g2clib/reduce.c
          degrib/g2clib/specunpack.c
          degrib/g2clib/rdieee.c
          degrib/g2clib/mkieee.c
          degrib/g2clib/int_power.c
          degrib/g2clib/simpack.c
          degrib/g2clib/compack.c
          degrib/g2clib/cmplxpack.c
          degrib/g2clib/misspack.c
          degrib/g2clib/dec_jpeg2000.cpp
          degrib/g2clib/jpcunpack.c
          degrib/degrib/hazard.c
      CORE_SOURCES
          gribdrivercore.cpp
      PLUGIN_CAPABLE_IF
          "NOT GDAL_USE_PNG_INTERNAL\\\;NOT GDAL_USE_ZLIB_INTERNAL"
      NO_DEPS
      NO_SHARED_SYMBOL_WITH_CORE)

if(NOT TARGET gdal_GRIB)
    return()
endif()

gdal_standard_includes(gdal_GRIB)

if (NOT USE_ONLY_EMBEDDED_RESOURCE_FILES)
    set(GDAL_DATA_FILES
        ${CMAKE_CURRENT_SOURCE_DIR}/data/grib2_table_versions.csv
        ${CMAKE_CURRENT_SOURCE_DIR}/data/grib2_center.csv
        ${CMAKE_CURRENT_SOURCE_DIR}/data/grib2_process.csv
        ${CMAKE_CURRENT_SOURCE_DIR}/data/grib2_subcenter.csv
        ${CMAKE_CURRENT_SOURCE_DIR}/data/grib2_table_4_2_0_0.csv
        ${CMAKE_CURRENT_SOURCE_DIR}/data/grib2_table_4_2_0_13.csv
        ${CMAKE_CURRENT_SOURCE_DIR}/data/grib2_table_4_2_0_14.csv
        ${CMAKE_CURRENT_SOURCE_DIR}/data/grib2_table_4_2_0_15.csv
        ${CMAKE_CURRENT_SOURCE_DIR}/data/grib2_table_4_2_0_16.csv
        ${CMAKE_CURRENT_SOURCE_DIR}/data/grib2_table_4_2_0_17.csv
        ${CMAKE_CURRENT_SOURCE_DIR}/data/grib2_table_4_2_0_18.csv
        ${CMAKE_CURRENT_SOURCE_DIR}/data/grib2_table_4_2_0_190.csv
        ${CMAKE_CURRENT_SOURCE_DIR}/data/grib2_table_4_2_0_191.csv
        ${CMAKE_CURRENT_SOURCE_DIR}/data/grib2_table_4_2_0_19.csv
        ${CMAKE_CURRENT_SOURCE_DIR}/data/grib2_table_4_2_0_1.csv
        ${CMAKE_CURRENT_SOURCE_DIR}/data/grib2_table_4_2_0_20.csv
        ${CMAKE_CURRENT_SOURCE_DIR}/data/grib2_table_4_2_0_21.csv
        ${CMAKE_CURRENT_SOURCE_DIR}/data/grib2_table_4_2_0_2.csv
        ${CMAKE_CURRENT_SOURCE_DIR}/data/grib2_table_4_2_0_3.csv
        ${CMAKE_CURRENT_SOURCE_DIR}/data/grib2_table_4_2_0_4.csv
        ${CMAKE_CURRENT_SOURCE_DIR}/data/grib2_table_4_2_0_5.csv
        ${CMAKE_CURRENT_SOURCE_DIR}/data/grib2_table_4_2_0_6.csv
        ${CMAKE_CURRENT_SOURCE_DIR}/data/grib2_table_4_2_0_7.csv
        ${CMAKE_CURRENT_SOURCE_DIR}/data/grib2_table_4_2_10_0.csv
        ${CMAKE_CURRENT_SOURCE_DIR}/data/grib2_table_4_2_10_191.csv
        ${CMAKE_CURRENT_SOURCE_DIR}/data/grib2_table_4_2_10_1.csv
        ${CMAKE_CURRENT_SOURCE_DIR}/data/grib2_table_4_2_10_2.csv
        ${CMAKE_CURRENT_SOURCE_DIR}/data/grib2_table_4_2_10_3.csv
        ${CMAKE_CURRENT_SOURCE_DIR}/data/grib2_table_4_2_10_4.csv
        ${CMAKE_CURRENT_SOURCE_DIR}/data/grib2_table_4_2_1_0.csv
        ${CMAKE_CURRENT_SOURCE_DIR}/data/grib2_table_4_2_1_1.csv
        ${CMAKE_CURRENT_SOURCE_DIR}/data/grib2_table_4_2_1_2.csv
        ${CMAKE_CURRENT_SOURCE_DIR}/data/grib2_table_4_2_20_0.csv
        ${CMAKE_CURRENT_SOURCE_DIR}/data/grib2_table_4_2_20_1.csv
        ${CMAKE_CURRENT_SOURCE_DIR}/data/grib2_table_4_2_20_2.csv
        ${CMAKE_CURRENT_SOURCE_DIR}/data/grib2_table_4_2_2_0.csv
        ${CMAKE_CURRENT_SOURCE_DIR}/data/grib2_table_4_2_2_3.csv
        ${CMAKE_CURRENT_SOURCE_DIR}/data/grib2_table_4_2_2_4.csv
        ${CMAKE_CURRENT_SOURCE_DIR}/data/grib2_table_4_2_2_5.csv
        ${CMAKE_CURRENT_SOURCE_DIR}/data/grib2_table_4_2_2_6.csv
        ${CMAKE_CURRENT_SOURCE_DIR}/data/grib2_table_4_2_3_0.csv
        ${CMAKE_CURRENT_SOURCE_DIR}/data/grib2_table_4_2_3_1.csv
        ${CMAKE_CURRENT_SOURCE_DIR}/data/grib2_table_4_2_3_2.csv
        ${CMAKE_CURRENT_SOURCE_DIR}/data/grib2_table_4_2_3_3.csv
        ${CMAKE_CURRENT_SOURCE_DIR}/data/grib2_table_4_2_3_4.csv
        ${CMAKE_CURRENT_SOURCE_DIR}/data/grib2_table_4_2_3_5.csv
        ${CMAKE_CURRENT_SOURCE_DIR}/data/grib2_table_4_2_3_6.csv
        ${CMAKE_CURRENT_SOURCE_DIR}/data/grib2_table_4_2_4_0.csv
        ${CMAKE_CURRENT_SOURCE_DIR}/data/grib2_table_4_2_4_10.csv
        ${CMAKE_CURRENT_SOURCE_DIR}/data/grib2_table_4_2_4_1.csv
        ${CMAKE_CURRENT_SOURCE_DIR}/data/grib2_table_4_2_4_2.csv
        ${CMAKE_CURRENT_SOURCE_DIR}/data/grib2_table_4_2_4_3.csv
        ${CMAKE_CURRENT_SOURCE_DIR}/data/grib2_table_4_2_4_4.csv
        ${CMAKE_CURRENT_SOURCE_DIR}/data/grib2_table_4_2_4_5.csv
        ${CMAKE_CURRENT_SOURCE_DIR}/data/grib2_table_4_2_4_6.csv
        ${CMAKE_CURRENT_SOURCE_DIR}/data/grib2_table_4_2_4_7.csv
        ${CMAKE_CURRENT_SOURCE_DIR}/data/grib2_table_4_2_4_8.csv
        ${CMAKE_CURRENT_SOURCE_DIR}/data/grib2_table_4_2_4_9.csv
        ${CMAKE_CURRENT_SOURCE_DIR}/data/grib2_table_4_2_local_Canada.csv
        ${CMAKE_CURRENT_SOURCE_DIR}/data/grib2_table_4_2_local_HPC.csv
        ${CMAKE_CURRENT_SOURCE_DIR}/data/grib2_table_4_2_local_index.csv
        ${CMAKE_CURRENT_SOURCE_DIR}/data/grib2_table_4_2_local_MRMS.csv
        ${CMAKE_CURRENT_SOURCE_DIR}/data/grib2_table_4_2_local_NCEP.csv
        ${CMAKE_CURRENT_SOURCE_DIR}/data/grib2_table_4_2_local_NDFD.csv
        ${CMAKE_CURRENT_SOURCE_DIR}/data/grib2_table_4_5.csv
    )
    set_property(
      TARGET ${GDAL_LIB_TARGET_NAME}
      APPEND
      PROPERTY RESOURCE "${GDAL_DATA_FILES}")
endif()

if (EMBED_RESOURCE_FILES)
    add_driver_embedded_resources(gdal_GRIB GDAL_ENABLE_DRIVER_GRIB_PLUGIN degrib/degrib/embedded_resources.c)
endif()
if (USE_ONLY_EMBEDDED_RESOURCE_FILES)
    target_compile_definitions(gdal_GRIB PRIVATE USE_ONLY_EMBEDDED_RESOURCE_FILES)
endif()

target_include_directories(
  gdal_GRIB PRIVATE $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/degrib/degrib>
                    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/degrib/g2clib> $<TARGET_PROPERTY:gdal_MEM,SOURCE_DIR>)
target_compile_options(gdal_GRIB PRIVATE ${GDAL_SOFTWARNFLAGS}) # FIXME: only needed for files within degrib/ actually

if (BUILD_APPS)
  target_compile_definitions(gdal_GRIB PRIVATE -DBUILD_APPS)
endif()

if (GDAL_USE_PNG_INTERNAL)
  gdal_add_vendored_lib(gdal_GRIB libpng)
  target_compile_definitions(gdal_GRIB PRIVATE -DUSE_PNG)
  target_sources(gdal_GRIB PRIVATE degrib/g2clib/pngunpack.c degrib/g2clib/dec_png.c)
endif()

if (GDAL_USE_ZLIB_INTERNAL)
  gdal_add_vendored_lib(gdal_GRIB libz)
endif ()

if (GDAL_USE_PNG AND NOT GDAL_USE_PNG_INTERNAL)
  target_compile_definitions(gdal_GRIB PRIVATE -DUSE_PNG)
  gdal_target_link_libraries(gdal_GRIB PRIVATE PNG::PNG)
  target_sources(gdal_GRIB PRIVATE degrib/g2clib/pngunpack.c degrib/g2clib/dec_png.c)
endif ()

if (GDAL_USE_ZLIB AND NOT GDAL_USE_ZLIB_INTERNAL)
  gdal_target_link_libraries(gdal_GRIB PRIVATE ZLIB::ZLIB)
endif ()

if (GDAL_USE_LIBAEC)
  target_compile_definitions(gdal_GRIB PRIVATE -DUSE_AEC)
  gdal_target_link_libraries(gdal_GRIB PRIVATE LIBAEC::LIBAEC)
  target_sources(gdal_GRIB PRIVATE degrib/g2clib/aecunpack.c)
endif ()

=== PKGBUILD ===
# Maintainer: Alexey Kasatkin <alexeikasatkin@gmail.com>
# ArchLinux maintainer: Jaroslav Lichtblau <dragonlord@aur.archlinux.org>
# Contributor: dibblethewrecker dibblethewrecker.at.jiwe.dot.org
# Contributor: William Rea <sillywilly@gmail.com>
# Contributor: Petri Moisio <petri.k.moisio@gmail.com>

_realname=gdal
pkgbase=mingw-w64-${_realname,,}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}"
         "${MINGW_PACKAGE_PREFIX}-python-${_realname}")
pkgver=3.11.3
pkgrel=1
pkgdesc="A translator library for raster geospatial data formats (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://gdal.org/"
msys2_repository_url="https://github.com/OSGeo/gdal"
msys2_references=(
  'archlinux: gdal'
  "cpe: cpe:/a:gdal:gdal"
  "cpe: cpe:/a:osgeo:gdal"
)
license=('spdx:MIT')
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-opencl-headers"
             "${MINGW_PACKAGE_PREFIX}-python-numpy"
             "${MINGW_PACKAGE_PREFIX}-python-setuptools"
             "${MINGW_PACKAGE_PREFIX}-swig"
             "${MINGW_PACKAGE_PREFIX}-xsimd")
depends=("${MINGW_PACKAGE_PREFIX}-cc-libs"
         "${MINGW_PACKAGE_PREFIX}-armadillo"
         "${MINGW_PACKAGE_PREFIX}-arrow"
         "${MINGW_PACKAGE_PREFIX}-blosc"
         "${MINGW_PACKAGE_PREFIX}-cfitsio"
         "${MINGW_PACKAGE_PREFIX}-crypto++"
         "${MINGW_PACKAGE_PREFIX}-curl"
         "${MINGW_PACKAGE_PREFIX}-expat"
         "${MINGW_PACKAGE_PREFIX}-geos"
         "${MINGW_PACKAGE_PREFIX}-giflib"
         "${MINGW_PACKAGE_PREFIX}-hdf4"
         "${MINGW_PACKAGE_PREFIX}-hdf5"
         "${MINGW_PACKAGE_PREFIX}-json-c"
         "${MINGW_PACKAGE_PREFIX}-lerc"
         "${MINGW_PACKAGE_PREFIX}-libaec"
         "${MINGW_PACKAGE_PREFIX}-libarchive"
         "${MINGW_PACKAGE_PREFIX}-libdeflate"
         "${MINGW_PACKAGE_PREFIX}-libfreexl"
         "${MINGW_PACKAGE_PREFIX}-libgeotiff"
         "${MINGW_PACKAGE_PREFIX}-libheif"
         "${MINGW_PACKAGE_PREFIX}-libiconv"
         "${MINGW_PACKAGE_PREFIX}-libjpeg"
         "${MINGW_PACKAGE_PREFIX}-libjxl"
         "${MINGW_PACKAGE_PREFIX}-libkml"
         "${MINGW_PACKAGE_PREFIX}-libpng"
         "${MINGW_PACKAGE_PREFIX}-libmariadbclient"
         "${MINGW_PACKAGE_PREFIX}-libspatialite"
         "${MINGW_PACKAGE_PREFIX}-libtiff"
         "${MINGW_PACKAGE_PREFIX}-libwebp"
         "${MINGW_PACKAGE_PREFIX}-libxml2"
         "${MINGW_PACKAGE_PREFIX}-lz4"
         "${MINGW_PACKAGE_PREFIX}-netcdf"
         "${MINGW_PACKAGE_PREFIX}-opencl-icd"
         "${MINGW_PACKAGE_PREFIX}-openexr"
         "${MINGW_PACKAGE_PREFIX}-openjpeg2"
         "${MINGW_PACKAGE_PREFIX}-openssl"
         "${MINGW_PACKAGE_PREFIX}-pcre2"
         $([[ ${CARCH} == aarch64 ]] || echo "${MINGW_PACKAGE_PREFIX}-podofo")
         "${MINGW_PACKAGE_PREFIX}-poppler"
         "${MINGW_PACKAGE_PREFIX}-postgresql"
         "${MINGW_PACKAGE_PREFIX}-proj"
         "${MINGW_PACKAGE_PREFIX}-qhull"
         "${MINGW_PACKAGE_PREFIX}-sfcgal"
         "${MINGW_PACKAGE_PREFIX}-sqlite3"
         #"${MINGW_PACKAGE_PREFIX}-tiledb"
         "${MINGW_PACKAGE_PREFIX}-xerces-c"
         "${MINGW_PACKAGE_PREFIX}-xz"
         "${MINGW_PACKAGE_PREFIX}-zlib"
         "${MINGW_PACKAGE_PREFIX}-zstd")
source=(https://github.com/OSGeo/gdal/releases/download/v${pkgver}/gdal-${pkgver}.tar.gz
        001-fix-bindings-install-path.patch
        002-remove-manual-soversion.patch)
sha256sums=('54638f6990f84c16142d93c9daaafaf1eab0a6a61538162095c334de086ef91f'
            'bfb0b42c8562bd45ae5cff71d42b042e398dff9a9c1f5bb08d8717a7753d4f3f'
            'fc815a58fe229db3c44bae15f405cafbeb82de91ec3f35564569c5bbecb1c3d7')

apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying $_patch"
    patch -Np1 -i "${srcdir}/$_patch"
  done
}

prepare() {
  cd "${srcdir}"/${_realname}-${pkgver}
  apply_patch_with_msg \
    001-fix-bindings-install-path.patch \
    002-remove-manual-soversion.patch
}

build() {
  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  if [[ ${CARCH} == x86_64 ]]; then
    _extra_config+=("-DGDAL_USE_PODOFO=ON")
  else
    _extra_config+=("-DGDAL_USE_PODOFO=OFF")
  fi

  msg2 "Building static library"
  mkdir -p "${srcdir}/build-${MSYSTEM}-static" && cd "${srcdir}/build-${MSYSTEM}-static"

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    "${MINGW_PREFIX}"/bin/cmake.exe \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      "${_extra_config[@]}" \
      -DBUILD_SHARED_LIBS=OFF \
      -DCMAKE_CXX_STANDARD=17 \
      -DBUILD_PYTHON_BINDINGS=OFF \
      -DGDAL_USE_INTERNAL_LIBS=OFF \
      -DGDAL_USE_HDFS=OFF \
      -DGDAL_USE_MSSQL_ODBC=OFF \
      -DGDAL_USE_POPPLER=ON \
      -DBUILD_TESTING=OFF \
      ../${_realname}-${pkgver}

  "${MINGW_PREFIX}"/bin/cmake.exe --build .

  msg2 "Building shared library"
  mkdir -p "${srcdir}/build-${MSYSTEM}-shared" && cd "${srcdir}/build-${MSYSTEM}-shared"

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    "${MINGW_PREFIX}"/bin/cmake.exe \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      "${_extra_config[@]}" \
      -DBUILD_SHARED_LIBS=ON \
      -DCMAKE_DLL_NAME_WITH_SOVERSION=ON \
      -DCMAKE_CXX_STANDARD=17 \
      -DBUILD_PYTHON_BINDINGS=ON \
      -DBUILD_JAVA_BINDINGS=OFF \
      -DGDAL_USE_INTERNAL_LIBS=OFF \
      -DGDAL_USE_HDFS=OFF \
      -DGDAL_USE_MSSQL_ODBC=OFF \
      -DGDAL_USE_POPPLER=ON \
      -DBUILD_TESTING=OFF \
      -DPython_EXECUTABLE=${MINGW_PREFIX}/bin/python \
      ../${_realname}-${pkgver}

  "${MINGW_PREFIX}"/bin/cmake.exe --build .
}

check () {
  cd "${srcdir}/build-${MSYSTEM}-shared"

  "${MINGW_PREFIX}"/bin/cmake.exe -DBUILD_TESTING=ON ../${_realname}-${pkgver}
  "${MINGW_PREFIX}"/bin/cmake.exe --build .
  "${MINGW_PREFIX}"/bin/ctest.exe .
}

package_gdal() {
  msg2 "Installing static library"
  cd "${srcdir}/build-${MSYSTEM}-static"
  DESTDIR="${pkgdir}" "${MINGW_PREFIX}"/bin/cmake.exe --install .

  msg2 "Installing shared library"
  cd "${srcdir}/build-${MSYSTEM}-shared"
  DESTDIR="${pkgdir}" "${MINGW_PREFIX}"/bin/cmake.exe --install .

  # install license
  install -Dm644 "${srcdir}/${_realname}-${pkgver}/LICENSE.TXT" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE"

  # Move python stuff
  mkdir -p "${srcdir}"/build-${MSYSTEM}-shared/{bin,lib}
  mv "${pkgdir}"${MINGW_PREFIX}/bin/*py "${srcdir}"/build-${MSYSTEM}-shared/bin
  mv "${pkgdir}"${MINGW_PREFIX}/lib/python* "${srcdir}"/build-${MSYSTEM}-shared/lib
}

package_python-gdal() {
  pkgdesc="Python bindings for GDAL (mingw-w64)"
  depends=("${MINGW_PACKAGE_PREFIX}-${_realname}"
           "${MINGW_PACKAGE_PREFIX}-python"
           "${MINGW_PACKAGE_PREFIX}-python-psycopg2"
           "${MINGW_PACKAGE_PREFIX}-python-numpy")

  msg2 "Installing Python bindings"
  cd "${srcdir}/build-${MSYSTEM}-shared"

  install -d "${pkgdir}"${MINGW_PREFIX}/{bin,lib}
  mv "${srcdir}"/build-${MSYSTEM}-shared/bin/* "${pkgdir}"${MINGW_PREFIX}/bin
  mv "${srcdir}"/build-${MSYSTEM}-shared/lib/* "${pkgdir}"${MINGW_PREFIX}/lib

  # fix python command in files
  local _mingw_prefix=$(cygpath -am ${MINGW_PREFIX})
  for _f in "${pkgdir}${MINGW_PREFIX}"/bin/*.py; do
    sed -e "s|${_mingw_prefix}/bin/|/usr/bin/env |g" -i ${_f}
  done
}

# template start; name=mingw-w64-splitpkg-wrappers; version=1.0;
# vim: set ft=bash :

# generate wrappers
for _name in "${pkgname[@]}"; do
  _short="package_${_name#${MINGW_PACKAGE_PREFIX}-}"
  _func="$(declare -f "${_short}")"
  eval "${_func/#${_short}/package_${_name}}"
done
# template end;
